TweakHub = LibStub("AceAddon-3.0"):NewAddon("TweakHub", "AceConsole-3.0")

local L = LibStub("AceLocale-3.0"):GetLocale("TweakHub")
local options = {
	name = "TweakHub",
	handler = TweakHub,
	type = "group",
	args = {}
}

function TweakHub:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("TweakHubDB", { }, "Default")

	LibStub("AceConfig-3.0"):RegisterOptionsTable("TweakHub", options, {"tweakhub", "th"})
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("TweakHub", "TweakHub")
	self:RegisterChatCommand("th", "ChatCommand")
	self:RegisterChatCommand("tweakhub", "ChatCommand")
end

function TweakHub:OnEnable()
	TweakHub:ResetOptionTables()
end

function TweakHub:ChatCommand(arg)
    if not arg or arg:trim() == "" then
        InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(TweakHub, "th", "tweakhub", arg)
    end
end

function TweakHub:ResetOptionTables(m)
	for moduleName, module in TweakHub:IterateModules() do
		if m == nil or m == moduleName then
			options.args[moduleName] = {
				type = "group",
				name = module.Name,
				args = {
					LoadOptionsTable = {
						type = "execute",
						name = L["Load Options Table"],
						desc = format(L["Load options table for %s."], moduleName),
						func = function()
							options.args[moduleName] = TweakHub[moduleName]:GetOptionsTable()
							options.args[moduleName].args.ClearOptionsTable = {
								type = "execute",
								name = L["Clear Option Table"],
								desc = L["Clear the option table to save addon memory. Causes garbage collection."],
								func = function() TweakHub:ResetOptionTables(moduleName) end,
								order = 999,
							}
						end,
					},
				},
			}
		end
	end
	collectgarbage()
end